import {
  isBrowser
} from "./chunk-YKE4UGGF.js";
import {
  getGlobalLogger
} from "./chunk-6KWR5DLV.js";
import {
  LoggerBrowserSetupDebugFactory
} from "./chunk-FASRHACU.js";
import {
  LoggerBrowserHandler
} from "./chunk-T4KEEC3Q.js";
import {
  isEmpty
} from "./chunk-EOHXRMVQ.js";

// src/browser/log/log-context-browser.ts
function Logger(name, level) {
  return getGlobalLogger((context) => {
    if (isBrowser() && !isEmpty(localStorage.getItem("zeed"))) {
      context.setHandlers([LoggerBrowserHandler()]);
      context.setFactory(LoggerBrowserSetupDebugFactory({}));
    }
  })(name, level);
}

export {
  Logger
};
//# sourceMappingURL=chunk-AZEFX6B2.js.map