"use strict";Object.defineProperty(exports, "__esModule", {value: true});


var _chunkOXPDHZDYcjs = require('./chunk-OXPDHZDY.cjs');


var _chunkNYVRXH32cjs = require('./chunk-NYVRXH32.cjs');

// src/common/log/log-memory.ts
function LoggerMemoryHandler(opt) {
  const { level = void 0, filter = void 0, messages = [] } = opt;
  const matchesNamespace = _chunkOXPDHZDYcjs.useNamespaceFilter.call(void 0, filter);
  const matchesLevel = _chunkOXPDHZDYcjs.useLevelFilter.call(void 0, level);
  return (msg) => {
    if (!matchesLevel(msg.level))
      return;
    if (!matchesNamespace(msg.name))
      return;
    msg.timestamp = _chunkNYVRXH32cjs.getTimestamp.call(void 0, );
    messages.push(msg);
  };
}



exports.LoggerMemoryHandler = LoggerMemoryHandler;
//# sourceMappingURL=chunk-BR4XCRA2.cjs.map