// src/common/global.ts
function _global() {
  if (typeof self !== "undefined")
    return self;
  if (typeof window !== "undefined")
    return window;
  if (typeof global !== "undefined")
    return global;
  if (typeof globalThis !== "undefined")
    return globalThis;
  throw new Error("unable to locate global object");
}
function getGlobalContext(defaultValue = {}) {
  const gcontext = _global();
  if (gcontext._zeedGlobal == null)
    gcontext._zeedGlobal = defaultValue;
  return gcontext._zeedGlobal;
}

export {
  getGlobalContext
};
//# sourceMappingURL=chunk-CFICINSP.js.map