"use strict";Object.defineProperty(exports, "__esModule", {value: true});











var _chunkJCNZZG5Scjs = require('./chunk-JCNZZG5S.cjs');














var _chunk5FE5DCG4cjs = require('./chunk-5FE5DCG4.cjs');


var _chunk2IXDQ4SYcjs = require('./chunk-2IXDQ4SY.cjs');


var _chunk66YRDFQPcjs = require('./chunk-66YRDFQP.cjs');

// src/common/bin/index.ts
var BinaryEncoder = class {
  async encode(data) {
    const dataEncoder = _chunk5FE5DCG4cjs.createEncoder.call(void 0, );
    _chunk5FE5DCG4cjs.writeAny.call(void 0, dataEncoder, data);
    return _chunk5FE5DCG4cjs.encodeToUint8Array.call(void 0, dataEncoder);
  }
  async decode(data) {
    return _chunkJCNZZG5Scjs.readAny.call(void 0, _chunkJCNZZG5Scjs.createDecoder.call(void 0, _chunk66YRDFQPcjs.toUint8Array.call(void 0, data)));
  }
};
function encodeJson(data) {
  const dataEncoder = _chunk5FE5DCG4cjs.createEncoder.call(void 0, );
  _chunk5FE5DCG4cjs.writeAny.call(void 0, dataEncoder, data);
  return _chunk5FE5DCG4cjs.encodeToUint8Array.call(void 0, dataEncoder);
}
function decodeJson(data) {
  return _chunkJCNZZG5Scjs.readAny.call(void 0, _chunkJCNZZG5Scjs.createDecoder.call(void 0, _chunk66YRDFQPcjs.toUint8Array.call(void 0, data)));
}
function createBinaryStreamEncoder(initialData) {
  const dataEncoder = _chunk5FE5DCG4cjs.createEncoder.call(void 0, );
  if (initialData != null)
    _chunk5FE5DCG4cjs.writeUint8Array.call(void 0, dataEncoder, _chunk66YRDFQPcjs.toUint8Array.call(void 0, initialData));
  return {
    /** Just writes the bytes. Length is not stored! */
    writeBytes: (data, expectedLength) => {
      const bin = _chunk66YRDFQPcjs.toUint8Array.call(void 0, data);
      _chunk2IXDQ4SYcjs.assertCondition.call(void 0, !(expectedLength != null && bin.length !== expectedLength), `Expected ${expectedLength} bytes, got ${bin.length}`);
      _chunk5FE5DCG4cjs.writeUint8Array.call(void 0, dataEncoder, bin);
    },
    writeBytesVar: (data) => _chunk5FE5DCG4cjs.writeVarUint8Array.call(void 0, dataEncoder, _chunk66YRDFQPcjs.toUint8Array.call(void 0, data)),
    writeUintVar: (data) => _chunk5FE5DCG4cjs.writeVarUint.call(void 0, dataEncoder, data),
    writeUint8: (data) => _chunk5FE5DCG4cjs.writeUint8.call(void 0, dataEncoder, data),
    writeUint16: (data) => _chunk5FE5DCG4cjs.writeUint16.call(void 0, dataEncoder, data),
    writeUint32: (data) => _chunk5FE5DCG4cjs.writeUint32.call(void 0, dataEncoder, data),
    writeIntVar: (data) => _chunk5FE5DCG4cjs.writeVarInt.call(void 0, dataEncoder, data),
    writeFloat: (data) => _chunk5FE5DCG4cjs.writeFloat32.call(void 0, dataEncoder, data),
    writeStringVar: (data) => _chunk5FE5DCG4cjs.writeVarString.call(void 0, dataEncoder, data),
    write: (data) => _chunk5FE5DCG4cjs.writeAny.call(void 0, dataEncoder, data),
    getUint8Array: () => _chunk5FE5DCG4cjs.encodeToUint8Array.call(void 0, dataEncoder),
    getLength: () => _chunk5FE5DCG4cjs.length.call(void 0, dataEncoder)
  };
}
function createBinaryStreamDecoder(data) {
  const dataDecoder = _chunkJCNZZG5Scjs.createDecoder.call(void 0, _chunk66YRDFQPcjs.toUint8Array.call(void 0, data));
  return {
    readBytes: (len) => _chunkJCNZZG5Scjs.readUint8Array.call(void 0, dataDecoder, len),
    readBytesVar: () => _chunkJCNZZG5Scjs.readVarUint8Array.call(void 0, dataDecoder),
    readUintVar: () => _chunkJCNZZG5Scjs.readVarUint.call(void 0, dataDecoder),
    readUint8: () => _chunkJCNZZG5Scjs.readUint8.call(void 0, dataDecoder),
    readUint16: () => _chunkJCNZZG5Scjs.readUint16.call(void 0, dataDecoder),
    readUint32: () => _chunkJCNZZG5Scjs.readUint32.call(void 0, dataDecoder),
    readIntVar: () => _chunkJCNZZG5Scjs.readVarInt.call(void 0, dataDecoder),
    readFloat: () => _chunkJCNZZG5Scjs.readFloat32.call(void 0, dataDecoder),
    readStringVar: () => _chunkJCNZZG5Scjs.readVarString.call(void 0, dataDecoder),
    read: () => _chunkJCNZZG5Scjs.readAny.call(void 0, dataDecoder),
    getOffset: () => dataDecoder.pos || 0
  };
}
function bitfield(bitfield2 = 0) {
  return {
    setBit: (bit, value = true) => value ? bitfield2 |= 1 << bit : bitfield2 &= ~(1 << bit),
    unsetBit: (bit) => bitfield2 &= 1 << bit,
    toggleBit: (bit) => bitfield2 ^= 1 << bit,
    getBit: (bit) => (bitfield2 & 1 << bit) !== 0,
    getValue: () => bitfield2
  };
}
async function blobToArrayBuffer(blob) {
  return await blob.arrayBuffer();
}
async function blobToUint8Array(blob) {
  const buffer = await blobToArrayBuffer(blob);
  if (buffer != null)
    return _chunk66YRDFQPcjs.toUint8Array.call(void 0, buffer);
}










exports.BinaryEncoder = BinaryEncoder; exports.encodeJson = encodeJson; exports.decodeJson = decodeJson; exports.createBinaryStreamEncoder = createBinaryStreamEncoder; exports.createBinaryStreamDecoder = createBinaryStreamDecoder; exports.bitfield = bitfield; exports.blobToArrayBuffer = blobToArrayBuffer; exports.blobToUint8Array = blobToUint8Array;
//# sourceMappingURL=chunk-RZVG4SAU.cjs.map