"use strict"; function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }require('../chunk-NU2LARFE.cjs');
require('../chunk-QLGR2XSS.cjs');
require('../chunk-TZ5ILUUG.cjs');
require('../chunk-D2NIELWZ.cjs');
require('../chunk-BXH2HPYJ.cjs');
require('../chunk-MA5RCT26.cjs');
require('../chunk-SDJIWERF.cjs');
require('../chunk-GZXW4GUH.cjs');
require('../chunk-TQJ3XFWQ.cjs');
require('../chunk-62FVEJL6.cjs');
require('../chunk-6S5FT6HM.cjs');
require('../chunk-QZHRO76T.cjs');
require('../chunk-EGSR2MZJ.cjs');
require('../chunk-YMHH3L5N.cjs');



var _chunkSUEJCT55cjs = require('../chunk-SUEJCT55.cjs');
require('../chunk-4B2XCWGL.cjs');
require('../chunk-BR4XCRA2.cjs');


var _chunkMSWKJBIGcjs = require('../chunk-MSWKJBIG.cjs');
require('../chunk-ZF6FSG4C.cjs');
require('../chunk-PTW4AXNQ.cjs');
require('../chunk-5CIFX7O6.cjs');
require('../chunk-BBX7CCGY.cjs');
require('../chunk-OXPDHZDY.cjs');
require('../chunk-IDBXAXLG.cjs');
require('../chunk-N46W55MH.cjs');
require('../chunk-UKD65B23.cjs');
require('../chunk-NYVRXH32.cjs');
require('../chunk-ZYPCVNSG.cjs');
require('../chunk-CXBBK7CI.cjs');
require('../chunk-R7WMTFSS.cjs');
require('../chunk-DRTH56G4.cjs');
require('../chunk-XWE2OTGL.cjs');
require('../chunk-KTC5RW57.cjs');
require('../chunk-A4VFMLAN.cjs');
require('../chunk-7XAMJGPO.cjs');
require('../chunk-RKOTNV3K.cjs');
require('../chunk-ZGKV237Z.cjs');
require('../chunk-UTZZGYAE.cjs');
require('../chunk-N7OUNPMM.cjs');
require('../chunk-MPD2DJAD.cjs');
require('../chunk-YELWQAMG.cjs');
require('../chunk-AZ5FKZIK.cjs');
require('../chunk-POMZSIOD.cjs');
require('../chunk-FEYF6QXS.cjs');
require('../chunk-X7YZP75W.cjs');
require('../chunk-3SM3C7HY.cjs');
require('../chunk-UXNJ5WZM.cjs');


var _chunkQYCE2TUJcjs = require('../chunk-QYCE2TUJ.cjs');
require('../chunk-ANZPWIO4.cjs');
require('../chunk-CEXYDYSH.cjs');
require('../chunk-PJXRDQ2A.cjs');
require('../chunk-6T6PI6XG.cjs');
require('../chunk-XDY4SRCL.cjs');
require('../chunk-FYLSPYV2.cjs');
require('../chunk-YKRFYR2Q.cjs');
require('../chunk-QU2LM4AI.cjs');
require('../chunk-BMRI2X66.cjs');
require('../chunk-66YRDFQP.cjs');
require('../chunk-7FPSHSSO.cjs');

// src/common/dispose-defer.spec.ts
var log = _chunkMSWKJBIGcjs.DefaultLogger.call(void 0, "dispose-test");
describe("dispose", () => {
  it("should dispose correctly", async () => {
    const disposeCalls = [];
    const dispose = _chunkSUEJCT55cjs.useDispose.call(void 0, "a");
    const y = dispose.track({
      dispose() {
        disposeCalls.push(1);
      }
    });
    dispose.track(() => {
      disposeCalls.push(2);
    });
    const x = {
      async dispose() {
        disposeCalls.push(3);
      }
    };
    dispose.track(x);
    dispose.track();
    dispose.track(async () => {
      disposeCalls.push(4);
    });
    expect(disposeCalls).toEqual([]);
    expect(dispose.getSize()).toEqual(4);
    await dispose.untrack(x);
    expect(disposeCalls).toEqual([3]);
    expect(dispose.getSize()).toEqual(3);
    await dispose.untrack(x);
    expect(disposeCalls).toEqual([3]);
    expect(dispose.getSize()).toEqual(3);
    _optionalChain([y, 'optionalCall', _ => _()]);
    _optionalChain([y, 'optionalCall', _2 => _2()]);
    await dispose.untrack(x);
    expect(disposeCalls).toEqual([3, 1]);
    expect(dispose.getSize()).toEqual(2);
    await dispose.dispose();
    expect(disposeCalls).toEqual([3, 1, 4, 2]);
    expect(dispose.getSize()).toEqual(0);
    await dispose();
    expect(disposeCalls).toEqual([3, 1, 4, 2]);
    expect(dispose.getSize()).toEqual(0);
  });
  it("should be a fancy dispose itself", () => {
    let x = 1;
    class Some {
      constructor() {
        this.dispose = _chunkSUEJCT55cjs.useDispose.call(void 0, log);
        this.dispose.track(() => {
          x = 2;
        });
      }
    }
    const obj = new Some();
    expect(x).toBe(1);
    void obj.dispose();
    expect(x).toBe(2);
  });
  it("should defer lifo", async () => {
    const stack = [];
    const defer = _chunkSUEJCT55cjs.useDefer.call(void 0, { mode: "lifo" });
    defer.add(() => stack.push("a"));
    defer.add(() => stack.push("b"));
    defer.add(() => stack.push("c"));
    expect(stack).toEqual([]);
    void defer(true);
    expect(stack).toEqual(["c", "b", "a"]);
  });
  it("should defer fifo", async () => {
    const stack = [];
    const defer = _chunkSUEJCT55cjs.useDefer.call(void 0, { mode: "fifo" });
    defer.add(() => stack.push("a"));
    defer.add(async () => stack.push("b"));
    defer.add(() => stack.push("c"));
    expect(stack).toEqual([]);
    await defer();
    expect(stack).toEqual(["a", "b", "c"]);
  });
  it("should dispose sync", async () => {
    const stack = [];
    const dispose = _chunkSUEJCT55cjs.useDispose.call(void 0, );
    dispose.add(() => stack.push("a"));
    dispose.add(() => stack.push("b"));
    dispose.add(() => stack.push("c"));
    expect(stack).toEqual([]);
    await dispose(true);
    expect(stack).toEqual(["c", "b", "a"]);
  });
  it("should dispose sync 2", async () => {
    const stack = [];
    const dispose = _chunkSUEJCT55cjs.useDispose.call(void 0, );
    dispose.add(() => stack.push("a"));
    dispose.add(() => stack.push("b"));
    dispose.add(async () => {
      await _chunkQYCE2TUJcjs.sleep.call(void 0, 1);
      stack.push("c");
    });
    expect(stack).toEqual([]);
    expect(dispose.sync).toThrowError();
  });
});
//# sourceMappingURL=dispose-defer.spec.cjs.map