"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }// src/common/localhost.ts
function isLocalHost(hostname = _nullishCoalesce(_optionalChain([globalThis, 'optionalAccess', _ => _.location, 'optionalAccess', _2 => _2.hostname]), () => ( ""))) {
  return ["::ffff:127.0.0.1", "localhost", "127.0.0.1", "", "::1", "::"].includes(
    hostname
  ) || hostname.startsWith("192.168.") || hostname.startsWith("10.0.") || hostname.endsWith(".local");
}



exports.isLocalHost = isLocalHost;
//# sourceMappingURL=chunk-H6AB4FMJ.cjs.map