"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }

var _chunkYHUMRT4Fcjs = require('./chunk-YHUMRT4F.cjs');


var _chunk55VDGA2Rcjs = require('./chunk-55VDGA2R.cjs');


var _chunk6XG57PHGcjs = require('./chunk-6XG57PHG.cjs');


var _chunkMSWKJBIGcjs = require('./chunk-MSWKJBIG.cjs');


var _chunkX7YZP75Wcjs = require('./chunk-X7YZP75W.cjs');

// src/node/log/log-context-node.ts
var _process = require('process'); var _process2 = _interopRequireDefault(_process);
function Logger(name, level) {
  return _chunkMSWKJBIGcjs.getGlobalLogger.call(void 0, (context) => {
    const handlers = [
      _chunk55VDGA2Rcjs.LoggerNodeHandler.call(void 0, {
        padding: 32,
        nameBrackets: false
        // levelHelper: false,
      })
    ];
    const logFilePath = _nullishCoalesce(_process2.default.env.ZEED_LOG, () => ( _process2.default.env.LOG));
    const time = _chunkX7YZP75Wcjs.valueToBoolean.call(void 0, _process2.default.env.ZEED_TIME, true);
    const pretty = _chunkX7YZP75Wcjs.valueToBoolean.call(void 0, _process2.default.env.ZEED_PRETTY, false);
    if (logFilePath)
      handlers.unshift(_chunkYHUMRT4Fcjs.LoggerFileHandler.call(void 0, _chunk6XG57PHGcjs.toPath.call(void 0, logFilePath), { time, pretty }));
    context.setHandlers(handlers);
  })(name, level);
}



exports.Logger = Logger;
//# sourceMappingURL=chunk-KSGL522D.cjs.map