"use strict";Object.defineProperty(exports, "__esModule", {value: true});



var _chunkOXPDHZDYcjs = require('./chunk-OXPDHZDY.cjs');




var _chunkIDBXAXLGcjs = require('./chunk-IDBXAXLG.cjs');

// src/common/log/log-console.ts
function LoggerConsoleHandler(opt = {}) {
  const {
    level = void 0,
    filter = void 0
    // colors = true,
    // levelHelper = false,
    // nameBrackets = true,
    // padding = 16,
  } = opt;
  const matchesNamespace = _chunkOXPDHZDYcjs.useNamespaceFilter.call(void 0, filter);
  const matchesLevel = _chunkOXPDHZDYcjs.useLevelFilter.call(void 0, level);
  return (msg) => {
    if (!matchesLevel(msg.level))
      return;
    if (!matchesNamespace(msg.name))
      return;
    const name = msg.name ? `[${msg.name}]` : "";
    switch (msg.level) {
      case _chunkIDBXAXLGcjs.LogLevelInfo:
        console.info(..._chunkOXPDHZDYcjs.joinLogStrings.call(void 0, `I|*   ${name}`, ...msg.messages));
        break;
      case _chunkIDBXAXLGcjs.LogLevelWarn:
        console.warn(..._chunkOXPDHZDYcjs.joinLogStrings.call(void 0, `W|**  ${name}`, ...msg.messages));
        break;
      case _chunkIDBXAXLGcjs.LogLevelError:
        console.error(..._chunkOXPDHZDYcjs.joinLogStrings.call(void 0, `E|*** ${name}`, ...msg.messages));
        break;
      default:
        console.debug(..._chunkOXPDHZDYcjs.joinLogStrings.call(void 0, `D|    ${name}`, ...msg.messages));
        break;
    }
  };
}



exports.LoggerConsoleHandler = LoggerConsoleHandler;
//# sourceMappingURL=chunk-PTW4AXNQ.cjs.map