declare function jsonStringifySorted(obj: any, indent?: number | undefined): string;
type EntryProcessor = (key: string, value: any) => any;
/**
 * Similar to JSON.stringify but can handle circular references.
 * NOT SORTED!
 * From https://github.com/moll/json-stringify-safe/blob/master/stringify.js
 * License ISC
 */
declare function jsonStringifySafe(obj: any, replacer?: EntryProcessor | null | undefined, spaces?: string | number | null, cycleReplacer?: EntryProcessor): string;
declare const jsonStringify: typeof jsonStringifySafe;
declare function jsonParse(val: string): any;

export { jsonParse as default, jsonStringify, jsonStringifySafe, jsonStringifySorted };
