import "../chunk-EW6FHLFK.js";
import "../chunk-MPAXUMZ5.js";
import "../chunk-YPA6GF7Q.js";
import "../chunk-BEAZFEOP.js";
import "../chunk-7OAUULYN.js";
import "../chunk-22B3ZREI.js";
import "../chunk-IQFZHKL7.js";
import "../chunk-MPAJZ5W6.js";
import "../chunk-PSY3LHMH.js";
import "../chunk-AJ3WFXQE.js";
import "../chunk-ENHLOA77.js";
import "../chunk-PJDBG5VS.js";
import "../chunk-F6OVXD4L.js";
import "../chunk-ULLOUKBT.js";
import "../chunk-EZN5PZBB.js";
import "../chunk-TSCDX4AS.js";
import "../chunk-JOSKYDY4.js";
import "../chunk-6KWR5DLV.js";
import "../chunk-Y4YCZV43.js";
import "../chunk-B4UKO53B.js";
import "../chunk-D6B6MYVG.js";
import "../chunk-RG6OSZW5.js";
import "../chunk-TN2XVUJ2.js";
import "../chunk-E6MPGGAE.js";
import "../chunk-I45WP5PM.js";
import "../chunk-MIZOLME5.js";
import {
  duration,
  parseDate
} from "../chunk-NJF7RWE7.js";
import "../chunk-CFICINSP.js";
import "../chunk-UHTVWILC.js";
import "../chunk-T7PU5CTZ.js";
import "../chunk-XSB2WAW2.js";
import "../chunk-NYCGHEIN.js";
import "../chunk-AS5LR4AI.js";
import "../chunk-5Y3HYG6B.js";
import "../chunk-AFUVZLZZ.js";
import "../chunk-X2DIUKLP.js";
import "../chunk-2HWPZ6ZE.js";
import "../chunk-UO5KXZLS.js";
import "../chunk-73CVRDI7.js";
import "../chunk-FL5CT6MC.js";
import "../chunk-HLRQ5H3N.js";
import "../chunk-BCFBEP5B.js";
import "../chunk-EOHXRMVQ.js";
import "../chunk-DGP32WEQ.js";
import "../chunk-PIOWR3HK.js";
import "../chunk-4XPO57AQ.js";
import "../chunk-ACZDEHYB.js";
import {
  sleep
} from "../chunk-FSDCRQB3.js";
import "../chunk-YEEGQOIW.js";
import "../chunk-AEBHR4XF.js";
import "../chunk-IZT6OHMS.js";
import "../chunk-GY34N3KU.js";
import "../chunk-NS4INNCL.js";
import "../chunk-TYWNSO7K.js";
import "../chunk-ZMFW3O35.js";
import "../chunk-R6KULE2F.js";
import "../chunk-7NSVDPHN.js";
import "../chunk-VVNSHVPQ.js";
import "../chunk-6GHO7LQW.js";

// src/common/time.spec.ts
describe("time.spec", () => {
  it("should measure", async () => {
    const getDuration = duration();
    await sleep(50);
    const elapsed = getDuration();
    expect(/\d+.\d\d ms/.test(elapsed)).toBe(true);
  });
  it("should parse valid date strings", () => {
    const date1 = parseDate("2022-01-01");
    const date2 = parseDate("2022-01-01T12:00:00");
    expect(date1).toEqual(new Date(2022, 0, 1, 12, 0));
    expect(date2).toEqual(/* @__PURE__ */ new Date("2022-01-01T12:00:00"));
  });
  it("should return undefined for invalid date strings", () => {
    const date = parseDate("invalid-date");
    expect(date).toBeUndefined();
  });
  it("should return the input date if it is already a Date object", () => {
    const inputDate = /* @__PURE__ */ new Date();
    const date = parseDate(inputDate);
    expect(date).toBe(inputDate);
  });
});
//# sourceMappingURL=time.spec.js.map